VERSION 5.00
Begin VB.Form frmMoveAlarm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "UI-View32 Station Movement Alarm"
   ClientHeight    =   6030
   ClientLeft      =   3360
   ClientTop       =   3720
   ClientWidth     =   7815
   HelpContextID   =   10
   Icon            =   "frmMoveWarn.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6030
   ScaleWidth      =   7815
   Begin VB.PictureBox picSymbol 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   300
      Left            =   7380
      ScaleHeight     =   20
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   20
      TabIndex        =   11
      Top             =   2220
      Visible         =   0   'False
      Width           =   300
   End
   Begin VB.TextBox txtHistory 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1470
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   9
      TabStop         =   0   'False
      ToolTipText     =   "Shows the history for one station"
      Top             =   2580
      Width           =   7575
   End
   Begin VB.TextBox txtStatus 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1470
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   5
      TabStop         =   0   'False
      ToolTipText     =   "List of movements, etc"
      Top             =   4440
      Width           =   7575
   End
   Begin VB.TextBox txtMinDist 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   6180
      MaxLength       =   9
      TabIndex        =   4
      ToolTipText     =   "Movements less than this are ignored"
      Top             =   1800
      Width           =   915
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "&Add callsign to list"
      Height          =   330
      Left            =   1620
      TabIndex        =   2
      ToolTipText     =   "Click to add callsign to list"
      Top             =   1800
      Width           =   1515
   End
   Begin VB.TextBox txtCallsign 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   120
      MaxLength       =   9
      TabIndex        =   1
      ToolTipText     =   "Input a callsign to add to list"
      Top             =   1800
      Width           =   1395
   End
   Begin VB.ListBox lstStations 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1410
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   0
      ToolTipText     =   "Double-click a station to show history. press Del to delete"
      Top             =   240
      Width           =   7575
   End
   Begin VB.Label labHistory2 
      AutoSize        =   -1  'True
      Caption         =   " (double-click the window to hide it) "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   1500
      TabIndex        =   12
      Top             =   2280
      Width           =   3180
   End
   Begin VB.Label labHistory 
      AutoSize        =   -1  'True
      Caption         =   "History for"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   180
      TabIndex        =   10
      Top             =   2280
      Width           =   885
   End
   Begin VB.Label labStatus 
      AutoSize        =   -1  'True
      Caption         =   "Status messages"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   180
      TabIndex        =   8
      Top             =   4140
      Width           =   1440
   End
   Begin VB.Label labUnits 
      AutoSize        =   -1  'True
      Caption         =   "yards"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   7200
      TabIndex        =   7
      Top             =   1860
      Width           =   465
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Ignore movement less than"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   3780
      TabIndex        =   3
      Top             =   1860
      Width           =   2295
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Callsign            Heard                Last Position                       Last Move"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   180
      TabIndex        =   6
      Top             =   0
      Width           =   6225
   End
   Begin VB.Menu mnuExit 
      Caption         =   "E&xit"
      HelpContextID   =   280
   End
   Begin VB.Menu mnuSetup 
      Caption         =   "&Setup"
      HelpContextID   =   270
      Begin VB.Menu mnuUnits 
         Caption         =   "&Units"
         Begin VB.Menu mnuIM 
            Caption         =   "&Imperial"
            Index           =   0
         End
         Begin VB.Menu mnuIM 
            Caption         =   "&Metric"
            Index           =   1
         End
      End
      Begin VB.Menu mnuAlarm 
         Caption         =   "&Audible Alarm"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
   End
End
Attribute VB_Name = "frmMoveAlarm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'This project is the source code for the Station Movement Alarm extra
'supplied with UI-View32. It is provided as an example of using UI-View32
'as an ActiveX component.
'
'I'm sure this application can be greatly improved, and there may well
'be some bugs in it, because I wrote it in a hurry. Hopefully, by
'"playing" with it, you should be able to learn how to use the ActiveX
'interface.
'
'If you make this application into something wonderful, feel free to
'let the world enjoy the results of your work!
'
'Good luck!
'
'G4IDE - 2000-Mar-28

Const SETUP_SECTION = "SETUP"

Public gintUnits As Integer
Public gstrBigUnits As String
Public gstrSmallUnits As String
Public WithEvents gUIV As clsUIV
Attribute gUIV.VB_VarHelpID = -1
Public gblnAudibleAlarm As Boolean
Public gblnHistoryShowing As Boolean

Private mclsSt() As clsStation
Private mintStCount As Integer
Private mStInfo As clsStationInfo
Private mstrIniFile As String
Private mstrListFile As String
Private mintLastLeft As Integer
Private mintLastTop As Integer
Private mintDiff As Integer
Private mblnClosingDown As Boolean

Private Declare Function GetPrivateProfileString Lib "kernel32" _
        Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, _
        ByVal lpKeyName As Any, ByVal lpDefault As String, _
        ByVal lpReturnedString As String, ByVal nSize As Long, _
        ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" _
        Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, _
        ByVal lpKeyName As Any, ByVal lpString As Any, _
        ByVal lpFileName As String) As Long
Private Declare Function WinHelp Lib "User32.dll" Alias "WinHelpA" _
        (ByVal hWnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, _
        ByVal dwData As Any) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, _
        ByVal x As Long, ByVal y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, _
        ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Private Function GetAPRSSymbol(strCallsign As String) As Boolean
Dim clsSt As New clsStationInfo
Dim intX As Integer
Dim intY As Integer
Dim lngClr As Long

picSymbol.Picture = LoadPicture("")

clsSt.strCallsign = strCallsign
If Not gUIV.GetStationInfo(clsSt) Then Exit Function

'The APRS symbol is put in picSymbol, then the background is made
'"transparent" by replacing it with the form background colour.
'This is pretty crap and is better done using a transparent BitBlt
'operation, but that would add quite a lot of complex code.

gUIV.GetAprsIcon clsSt.strOverlayChar, clsSt.strSymbol
picSymbol.Picture = Clipboard.GetData(vbCFBitmap)
'This alows for the form BackColor being either a system colour
'or a palette colour.
lngClr = frmMoveAlarm.BackColor
If lngClr < 0 Then lngClr = GetSysColor(lngClr + &H7FFFFFFF + 1)
For intX = 0 To picSymbol.ScaleWidth - 1
    For intY = 0 To picSymbol.ScaleHeight - 1
        If GetPixel(picSymbol.hdc, intX, intY) = picSymbol.BackColor Then _
            SetPixel picSymbol.hdc, intX, intY, lngClr
    Next intY
Next intX

GetAPRSSymbol = True

End Function

Public Sub HideHistoryWindow(blnUpdateStations As Boolean)
Dim intI As Integer

On Error Resume Next

If Not gblnHistoryShowing Then Exit Sub

'make sure no history flag is set.
If blnUpdateStations Then
    For intI = 0 To mintStCount - 1
        If Not mclsSt(intI) Is Nothing Then _
                mclsSt(intI).blnHistory = False
    Next intI
End If

labStatus.Top = labStatus.Top - mintDiff
txtStatus.Top = txtStatus.Top - mintDiff
Height = Height - mintDiff
labHistory.Visible = False
labHistory2.Visible = False
txtHistory.Visible = False
picSymbol.Visible = False
gblnHistoryShowing = False

Exit Sub

End Sub

Private Function IsitTrue(strA As String) As Integer

strA = UCase$(strA)
If strA = "YES" Or strA = "TRUE" Or strA = "1" Or strA = "ON" Then IsitTrue = True

End Function

Private Sub LoadList()
Dim intFd As Integer
Dim intI As Integer
Dim strA As String

On Error GoTo LoadListErr

intFd = FreeFile
Open mstrListFile For Input As intFd

Do While Not EOF(intFd)
    Line Input #intFd, strA
    AddToStationList strA, False
Loop

LoadListErr:
If intFd <> 0 Then Close intFd
Exit Sub

End Sub

Sub SaveIni()
Dim blnMin As Boolean

WritePrivateProfileString SETUP_SECTION, "MIN_DISTANCE", Trim$(txtMinDist), mstrIniFile

blnMin = (WindowState = vbMinimized)
If Not blnMin Then
    mintLastLeft = Left
    mintLastTop = Top
End If
WritePrivateProfileString SETUP_SECTION, "LEFT", Format$(mintLastLeft), mstrIniFile
WritePrivateProfileString SETUP_SECTION, "TOP", Format$(mintLastTop), mstrIniFile
WritePrivateProfileString SETUP_SECTION, "MINIMIZED", TrueOrFalse(blnMin), mstrIniFile

End Sub

Private Sub SaveList()
Dim intFd As Integer
Dim intI As Integer

On Error GoTo SaveListErr

intFd = FreeFile
Open mstrListFile For Output As intFd

For intI = 0 To mintStCount - 1
    If Not mclsSt(intI) Is Nothing Then
        Print #intFd, mclsSt(intI).strCallsign
    End If
Next intI

SaveListErr:
If intFd <> 0 Then Close intFd
Exit Sub

End Sub

Public Sub ShowHistoryWindow(strCallsign As String)
Static blnGotSymbol As Boolean
Static strLastCallsign As String

If strLastCallsign <> strCallsign Then
    strLastCallsign = strCallsign
    labHistory = "History for " & strCallsign & " "
    picSymbol.Left = labHistory.Left + labHistory.Width
    labHistory2.Left = picSymbol.Left + picSymbol.Width
    blnGotSymbol = False
End If

If Not blnGotSymbol Then blnGotSymbol = GetAPRSSymbol(strCallsign)

If gblnHistoryShowing Then Exit Sub

labStatus.Top = labStatus.Top + mintDiff
txtStatus.Top = txtStatus.Top + mintDiff
Height = Height + mintDiff
labHistory.Visible = True
labHistory2.Visible = True
txtHistory.Visible = True
picSymbol.Visible = True
gblnHistoryShowing = True

End Sub

Private Function TrueOrFalse(blnI As Boolean) As String

If blnI = False Then TrueOrFalse = "FALSE" Else TrueOrFalse = "TRUE"

End Function

Private Sub AddToStationList(strC As String, blnVerbose)
Dim intI As Integer
Dim intEmptySlot As Integer

intEmptySlot = -1

'Is it already in list?
For intI = 0 To mintStCount - 1
    If mclsSt(intI) Is Nothing Then
        intEmptySlot = intI
    ElseIf mclsSt(intI).strCallsign = strC Then
        If blnVerbose Then MsgBox strC & " is already in the list.", vbCritical, MBOX_TITLE
        Exit Sub
    End If
Next intI

If intEmptySlot = -1 Then
    intEmptySlot = mintStCount
    ReDim Preserve mclsSt(mintStCount)
    mintStCount = mintStCount + 1
End If

Set mclsSt(intEmptySlot) = New clsStation

mclsSt(intEmptySlot).strCallsign = strC
mclsSt(intEmptySlot).Init intEmptySlot

Exit Sub

End Sub

Private Sub LoadIni()
Dim strA As String
Dim intI As Integer

strA = GetIniStringWriteDefault(mstrIniFile, SETUP_SECTION, "UNITS", "0")
gintUnits = Val(strA)
mnuIM(gintUnits).Checked = True

strA = GetIniStringWriteDefault(mstrIniFile, SETUP_SECTION, "MIN_DISTANCE", "100")
txtMinDist = Trim$(strA)

strA = GetIniStringWriteDefault(mstrIniFile, SETUP_SECTION, "AUDIBLE_ALARM", "TRUE")
gblnAudibleAlarm = IsitTrue(strA)
mnuAlarm.Checked = gblnAudibleAlarm

intI = (Screen.Width - Width) / 2
strA = GetIniStringWriteDefault(mstrIniFile, SETUP_SECTION, "LEFT", Format$(intI))
Left = Val(strA)

intI = (Screen.Height - Height) / 2
strA = GetIniStringWriteDefault(mstrIniFile, SETUP_SECTION, "TOP", Format$(intI))
Top = Val(strA)

strA = GetIniStringWriteDefault(mstrIniFile, SETUP_SECTION, "MINIMIZED", "FALSE")
If IsitTrue(strA) Then WindowState = vbMinimized

End Sub

Private Sub SetupUnits()

If gintUnits = Imperial Then
    labUnits = "yards"
    gstrBigUnits = " miles"
    gstrSmallUnits = " yd"
Else
    labUnits = "metres"
    gstrBigUnits = " km"
    gstrSmallUnits = " m"
End If

End Sub

Private Function ToUpper(intK As Integer) As Integer

ToUpper = Asc(UCase$(Chr$(intK)))

End Function

Private Sub SelectAll()

ActiveControl.SelStart = 0
ActiveControl.SelLength = &H7FFF

End Sub

Private Sub cmdAdd_Click()
Dim strC As String

strC = Trim$(txtCallsign)

If strC = "" Then
    MsgBox "You're supposed to put a callsign in the box!", vbCritical, MBOX_TITLE
    Exit Sub
End If

AddToStationList strC, True
txtCallsign = ""

End Sub

Private Sub Form_Load()

'This is to get round a bug in the VB5 IDE that can result
'in forms with BorderStyle set to Fixed Single not displaying
'with the correct height.
Height = 6720

App.HelpFile = App.Path & "\" & App.EXEName & ".HLP"

Caption = Caption & " V" & App.Major & "." & App.Minor & App.Revision
mstrIniFile = App.Path & "\" & App.EXEName & ".INI"
mstrListFile = App.Path & "\" & App.EXEName & ".LST"
LoadIni
SetupUnits

picSymbol.Width = 20 * Screen.TwipsPerPixelX
picSymbol.Height = 20 * Screen.TwipsPerPixelY

mintDiff = txtStatus.Top - txtHistory.Top
gblnHistoryShowing = True
HideHistoryWindow False
Show
DoEvents

Set gUIV = New clsUIV
Set mStInfo = New clsStationInfo

LoadList

End Sub

Private Sub Form_Resize()

If WindowState <> vbMinimized Then
    mintLastLeft = Left
    mintLastTop = Top
End If

End Sub

Private Sub Form_Unload(Cancel As Integer)
Const HELP_QUIT = 2

'As the instances of clsStation are terminated, if the history
'window is open, an attempt will be made to close it. This can
'cause problems if this app is closing as a result of UI-View32
'being closed, so make sure that it can't happen.
gblnHistoryShowing = False

WinHelp hWnd, App.HelpFile, HELP_QUIT, Chr$(0) + Chr$(0) + Chr$(0) + Chr$(0)
SaveList
SaveIni

End Sub

Private Sub gUIV_NotifyBeacon(strCallsign As String, sngLat As Single, sngLong As Single)
Dim intI As Integer

For intI = 0 To mintStCount - 1
    If Not mclsSt(intI) Is Nothing Then
        'Note - A blank callsign with lat and long set to SILLY_NEG signals that
        'all stations have been deleted in UI-View.
        If mclsSt(intI).strCallsign = strCallsign Or strCallsign = "" Then
            mclsSt(intI).UpdateStInfo sngLat, sngLong
        End If
    End If
Next intI

End Sub

Private Sub gUIV_UIView32IsClosing()

Unload Me

End Sub

Private Sub lstStations_DblClick()
Dim intIndex As Integer
Dim intItemData As Integer
Dim intI As Integer

intIndex = lstStations.ListIndex
If intIndex < 0 Then Exit Sub

intItemData = lstStations.ItemData(intIndex)

'Enable history for the station that was double-clicked,
'Disable history for all the others.
For intI = 0 To mintStCount - 1
    If Not mclsSt(intI) Is Nothing Then
        If mclsSt(intI).intIndex = intItemData Then
            mclsSt(intI).blnHistory = True
        Else
            mclsSt(intI).blnHistory = False
        End If
    End If
Next intI

End Sub

Private Sub lstStations_KeyDown(KeyCode As Integer, Shift As Integer)
Dim intIndex As Integer
Dim intI As Integer
Dim intJ As Integer
Dim intItemData As Integer

If KeyCode <> vbKeyDelete Then Exit Sub

intIndex = lstStations.ListIndex
If intIndex < 0 Then Exit Sub
intItemData = lstStations.ItemData(intIndex)
lstStations.RemoveItem intIndex

'Remove the station from the array by setting it to nothing.
'The blank slot will be reused.
For intI = 0 To mintStCount - 1
    If Not mclsSt(intI) Is Nothing Then
        If mclsSt(intI).intIndex = intItemData Then
            Set mclsSt(intI) = Nothing
            Exit For
        End If
    End If
Next intI

'Adjust the ListBox list index.
If mintStCount = 0 Then Exit Sub
If intIndex > lstStations.ListCount - 1 Then intIndex = lstStations.ListCount - 1
lstStations.ListIndex = intIndex

End Sub

Private Function GetIniString(strFname As String, section As String, KeyName As String, KeyDefault As String)
Dim lngX As Long
Dim strTmp As String

strTmp = Space$(500)

lngX = GetPrivateProfileString(section, KeyName, KeyDefault, strTmp, Len(strTmp), strFname)
GetIniString = Left(strTmp, lngX)

End Function

Private Function GetIniStringWriteDefault(strIniName As String, strSection As String, strParam As String, strDefault As String) As String
Dim strA As String
Dim intRet As Integer

strA = GetIniString(strIniName, strSection, strParam, strDefault)

If strA = strDefault Then
    intRet = WritePrivateProfileString(strSection, strParam, strDefault, strIniName)
End If

GetIniStringWriteDefault = strA

End Function

Private Sub lstStations_KeyPress(KeyAscii As Integer)

If KeyAscii = vbKeyReturn Then lstStations_DblClick

End Sub

Private Sub mnuAlarm_Click()

gblnAudibleAlarm = Not gblnAudibleAlarm
mnuAlarm.Checked = gblnAudibleAlarm
WritePrivateProfileString SETUP_SECTION, "AUDIBLE_ALARM", TrueOrFalse(gblnAudibleAlarm), mstrIniFile

End Sub

Private Sub mnuExit_Click()

Unload Me

End Sub

Private Sub mnuHelp_Click()
Const HELP_CONTENTS = 3

WinHelp hWnd, App.HelpFile, HELP_CONTENTS, 0&

End Sub

Private Sub mnuIM_Click(Index As Integer)

gintUnits = Index
SetupUnits
mnuIM(Index).Checked = True
mnuIM((Index + 1) Mod 2).Checked = False

WritePrivateProfileString SETUP_SECTION, "UNITS", Format$(gintUnits), mstrIniFile

End Sub

Private Sub txtCallsign_GotFocus()

SelectAll

End Sub

Private Sub txtCallsign_KeyPress(KeyAscii As Integer)

KeyAscii = ToUpper(KeyAscii)

If KeyAscii = vbKeySpace Then
    KeyAscii = 0
ElseIf KeyAscii = vbKeyReturn Then
    cmdAdd_Click
    KeyAscii = 0
End If

End Sub

Private Sub txtHistory_DblClick()

HideHistoryWindow True

End Sub

Private Sub txtMinDist_GotFocus()

SelectAll

End Sub

Private Sub txtMinDist_KeyPress(KeyAscii As Integer)
Dim strA As String

If KeyAscii >= vbKeySpace And Not (KeyAscii >= Asc("0") And KeyAscii <= Asc("9")) Then
    KeyAscii = 0
End If

End Sub

